<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <v-container>
    <v-navigation-drawer v-model="isOpen" temporary app right color="background" width="200px">
      <!-- Close button -->
      <v-container class="d-flex justify-end">
        <v-btn class="exit-button" icon large @click="isOpen = false">
          <v-icon> mdi-close </v-icon>
        </v-btn>
      </v-container>

      <!-- Logged in  -->
      <template v-if="$auth.loggedIn">
        <nuxt-link
          v-for="link in linksAuth"
          :key="link.target"
          exact-active-class="link-active"
          :to="localePath(link.target)"
          class="studium-clickable-text"
          style="text-decoration: none"
        >
          <div class="link-container">
            {{ link.name }}
          </div>
        </nuxt-link>

        <div class="link-container" @click="$auth.logout()">
          <a class="studium-clickable-text">Log out <v-icon>mdi-logout</v-icon></a>
        </div>
      </template>

      <!-- Logged out -->
      <template v-else>
        <nuxt-link
          v-for="link in linksGuest"
          :key="link.target"
          exact-active-class="link-active"
          :to="localePath(link.target)"
          class="studium-clickable-text"
          style="text-decoration: none"
        >
          <div class="link-container">
            {{ link.name }}
          </div>
        </nuxt-link>

        <div class="link-container" @click="$auth.login()">
          <a class="studium-clickable-text">Log in <v-icon class="logout-icon">mdi-logout</v-icon></a>
        </div>
      </template>

      <!-- Footer -->
      <div class="bottom">
        <p>
          <!-- Privacy Policy -->
          <nuxt-link
            class="studium-clickable-text"
            :to="localePath({ name: 'agreements-name', params: { name: 'privacy' } })"
          >
            {{ $t('footbar.privacy') }}
          </nuxt-link>

          <!-- Terms of Service -->
          <nuxt-link
            class="studium-clickable-text"
            :to="localePath({ name: 'agreements-name', params: { name: 'terms' } })"
          >
            {{ $t('footbar.terms') }}
          </nuxt-link>

          <!-- Cookies -->
          <a class="studium-clickable-text" href="https://www.ugent.be/en/cookies" target="blank">
            {{ $t('footbar.cookies') }}
          </a>

          <!-- Contact -->
          <nuxt-link v-show="$auth.loggedIn" class="studium-clickable-text" :to="localePath('/contact')">
            {{ $t('footbar.contact') }}
          </nuxt-link>
          <a v-show="!$auth.loggedIn" class="studium-clickable-text" href="mailto:contact@studium.gent">
            {{ $t('footbar.contact') }}
          </a>
        </p>

        <!-- Copyright -->
        <p>
          Copyright @ {{ new Date().getFullYear() }}
          <a class="studium-clickable-text" style="text-decoration: none" href="https://www.vtk.ugent.be">
            VTK Ghent vzw.
          </a>
          All rights reserved.
        </p>
      </div>
    </v-navigation-drawer>
  </v-container>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // If the sidebar should be shown or hidden.
    sidebar: {
      type: Boolean,
    },

    // Links for authenticated users.
    linksAuth: {
      type: Array,
      default() {
        return [
          {
            name: 'My courses',
            target: '/',
          },
          {
            name: 'Search',
            target: '/search',
          },
        ]
      },
    },

    // Links for guests?.
    linksGuest: {
      type: Array,
      default() {
        return [
          {
            name: 'About',
            target: '/about',
          },
        ]
      },
    },
  },
  setup(props, { emit }) {
    // If the sidebar should be shown or hidden.
    const isOpen = useVModel(props, 'sidebar', emit)

    return {
      isOpen,
    }
  },
})
</script>

<style lang="scss" scoped>
// ---------------------------//
//   Style for page  links    //
// ---------------------------//

.link-container {
  padding-left: 10px;
  margin-left: 15px;
  margin-bottom: 16px;
  font-size: 18px;
  cursor: pointer;
}

.link-active {
  .link-container {
    border-left: 3px solid $primary;
    padding-left: 8px;
    margin-left: 14px;
  }
}

// ---------------------------//
// Styling for logout section //
// ---------------------------//

.bottom {
  position: absolute;
  bottom: 0%;
  padding: 20px;

  p {
    font-size: 12px;
    color: $secondary;

    a {
      display: block;
    }
  }
}
</style>
